\documentclass[final,a4paper]{article}

\usepackage{etex}
\reserveinserts{28}
\usepackage{amscd}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{amsthm}
\usepackage{cases}
\usepackage{t1enc}
\usepackage{array}
\usepackage[utf8]{inputenc}
\usepackage{graphicx}
%\usepackage{hyperref,fancybox}
\usepackage[usenames, svgnames]{xcolor}
\usepackage{ifpdf}
\usepackage{pgf,tikz}
\usetikzlibrary{matrix,arrows,decorations.pathmorphing,calc}
\usepackage[tikz]{bclogo}
\usepackage{epstopdf}
\usepackage{showkeys}
%\usepackage{bbold}
\usepackage{dsfont}
%\usepackage{arydshln}
\usepackage[ruled]{algorithm}            % algo
\usepackage{algorithmicx} %ctan.org\pkg\algorithms
%\usepackage{algorithmic}

\usepackage{algpseudocode}
\usepackage{varwidth}
%\usepackage{algorithmic}
\usepackage{caption}
\usepackage[matha,mathx,mathb]{mathabx}  % info
\usepackage{listings}
\usepackage{capt-of}

%\usepackage{showkeys}
%%%%%%%%%%%%%%%%%%%%
% Add for correction
%
\usepackage{xkvltxp}
\usepackage[draft,multiuser,french,inlineface=\bfseries]{fixme}
\fxusetheme{colorsig}
\FXRegisterAuthor{fc}{afc}{FC} % Francois Cuvelier
\FXRegisterAuthor{cj}{acj}{CJ} % Caroline Japhet
\FXRegisterAuthor{gs}{ags}{GS} % Gilles Scarella
\fxuselayouts{pdfnote}
%\fxuselayouts{marginnote}
%\newcommand{\FCnote}[1]{\fxnote{#1}}
%%%%%%%%%%%%%%%%%%%%

% some definitions to make Figures easier
\newcommand{\zoom}{0.36}
\newcommand{\zoomdeux}{0.35}
\graphicspath{{./images/}{./}}
\DeclareGraphicsRule{.ps}{eps}{.ps}{}
\DeclareGraphicsExtensions{.eps}
\newcommand{\imageps}[2]{
  \begin{center}
    \hspace{-0.5cm}
    \includegraphics*[scale={#2}]{#1}
  \end{center}}
\newcommand{\dblimageps}[4]{
  \begin{center}
    \hspace{-0.5cm}
    \includegraphics*[scale={#2}]{#1}
    \includegraphics*[scale={#4}]{#3}
  \end{center}}

\newcommand{\dblimagepss}[4]{
  \begin{center}
%    \hspace{-0.8cm}
    \includegraphics*[scale={#2}]{#1}
     \hspace{-0.8cm}
    \includegraphics*[scale={#4}]{#3}
  \end{center}}

\newcommand{\BenchFigure}[5]{
\begin{figure}[H]
  \centering
\dblimageps{#1}{\zoom}
{#2}{\zoom}
\imageps{#3}{\zoom}
\caption{#4 \label{#5}}
\end{figure}
}  
  
\newcommand{\BenchTabular}[6]{
\begin{table}[htbp]
\begin{center}
\begin{tabular}{@{}c@{}}
\begin{tabular}{@{}cc@{}}
\tiny{\textbf{#6 - Matlab}} & \tiny{\textbf{#6 - Octave}} \\
\tiny{\input{#1}}
&
\tiny{\input{#2}}
\end{tabular} 
\vspace{0.15cm}\\ 

\begin{tabular}{@{}c@{}}
\tiny{\textbf{#6 - Python}}\\
\tiny{\input{#3}}
\end{tabular}
\end{tabular}
\vspace{0.15cm}

\captionof{table}{#4}\label{#5}
\end{center}
\end{table}
}      
  
% some definitions to make typing easier
\newtheorem{theorem}{Theorem}
\newtheorem{proposition}[theorem]{Proposition}
\newtheorem{lemma}[theorem]{Lemma}
%\input{./latex/tikz_macros.sty}

% Listings width
\def\ListingWidth{0.8\textwidth}
\algrenewcommand\algorithmicindent{1.0em}
\algrenewcommand{\algorithmicrequire}{\tiny \textbf{\tiny{Input:}}}
\algrenewcommand{\algorithmicensure}{\small{ \textbf{Output:}}}
\algrenewcommand{\alglinenumber}[1]{\color{red!80!blue}\footnotesize#1:}
\usepackage{calc} % for \widthof
\algrenewcommand\algorithmicfunction{\widthof{\textbf{\small{Function}}}}
\algrenewcommand{\algorithmiccomment}[1]{{\color{Green}\hfill\footnotesize $\vartriangleright$ #1}} %$\rhd$
\algnewcommand\algorithmicto{\textbf{to}}
 \algrenewtext{For}[3]%
   {\algorithmicfor\ $#1 \gets #2$ \algorithmicto\ $#3$ \algorithmicdo}
%\renewcommand{\algorithmiccomment}[1]{\hfill\eqparbox{COMMENT}{\# #1}}
\makeatletter
\renewcommand{\ALG@beginalgorithmic}{\small}

\let\OldStatex\Statex
\renewcommand{\Statex}[1][3]{%
  \setlength\@tempdima{\algorithmicindent}%
  \OldStatex\hskip\dimexpr#1\@tempdima\relax}
\newcommand{\StatexIndent}[1][3]{%
  \setlength\@tempdima{\algorithmicindent}%
  \Statex\hskip\dimexpr#1\@tempdima\relax}
\makeatother

  %\makebox[\widthof{\textbf{Function:}}][l]{\textbf{Function:}}}
%\algsetup{linenosize=\small}

%

\usepackage{datetime}

\makeatletter
\renewcommand*{\@fnsymbol}[1]{\ensuremath{\ifcase#1\or *\or
     \mathsection\or \mathparagraph\or \|\or **\or \dagger\dagger
     \or \ddagger\ddagger \else\@ctrerr\fi}}
\makeatother

\usepackage{hyperref,fancybox}
\makeatletter
     \@addtoreset{figure}{section}
     \@addtoreset{table}{section}
     \usepackage{marginnote}
     %\usepackage[top=1.5cm, bottom=1.5cm, outer=1cm, inner=2cm, heightrounded, marginparwidth=2.5cm, marginparsep=2cm]{geometry}
\makeatother

\definecolor{freeblue}{rgb}{0.25,0.41,0.88}
\newcommand{\CJ}[1]{#1}
\newcommand{\CJa}[1]{#1}
\newcommand{\FC}[1]{{\color{blue} #1}}
\newcommand{\GS}[1]{#1}
\newcommand{\FCnote}[1]{\marginnote{\color{red} #1}[0cm]}
% \newcommand{\CJ}[1]{{\color{magenta}{#1}}}
% \newcommand{\CJa}[1]{{\color{green}{#1}}}
% \newcommand{\FC}[1]{{\color{blue}{#1}}}
%\newcommand{\GS}[1]{{\color{red}{#1}}}
% Used for tabulars results in appendix
\newcolumntype{C}[1]{>{\centering\let\newline\\\arraybackslash\hspace{0pt}}m{#1}}


\newif\ifstartedinmathmode
\newcommand{\FName}[1]{ {\footnotesize \color{DarkRed} \ifstartedinmathmode\mbox{\textsc{#1}}\else\textsc{#1}\fi }}
\newcommand{\FNameDef}[1]{\footnotesize {\color{red} \ifstartedinmathmode\mbox{\textsc{#1}}\else\textsc{#1}\fi }}
\newcommand{\FNameStd}[1]{\footnotesize {\color{blue} \ifstartedinmathmode\mbox{\textsc{#1}}\else\textsc{#1}\fi }}
\newcommand{\raisedrule}[2][0em]{\leaders\hbox{\rule[#1]{1pt}{#2}}\hfill}
\newcommand{\SeeAlso}[2]{
\begin{minipage}{#1}
\footnotesize{\color{violet}{
\textbf{\textit{See also :}} #2
}}
\end{minipage}}

\newcommand{\Input}[2]{
\begin{minipage}{#1}
\footnotesize \textbf{Input :}\\
#2 \\
\end{minipage}\\
}
\newcommand{\Output}[2]{
\begin{minipage}{#1}
\footnotesize \textbf{Output :}\\
#2 
\end{minipage}\\
}
\newcommand{\tensorii}[1]{\underline{\underline{#1}}\,}
\newcommand{\tensoriii}[1]{\underline{\underline{\underline{#1}}}\,}

\newcommand{\tensoriv}[1]{\underline{\underline{\underline{\underline{#1}}}}\,}
%=======================================================================================================

\newcommand{\dsp}{\displaystyle}
\newcommand{\DP}[2]{\dsp\frac{\partial {#1}}{\partial {#2}}}
\newcommand{\DPP}[2]{\dsp\frac{\partial^2 {#1}}{\partial {#2}}}
\newcommand{\GSbe}{\begin{eqnarray*}}
\newcommand{\GSee}{\end{eqnarray*}}     
\begin{document}
\reversemarginpar % For todonotes package
\tableofcontents
\section{Wave equation with time explicit scheme}
The wave equation with Dirichlet boundary conditions writes
\GSbe
\DPP{u}{t}- \mu\,\Delta u &=& f \hbox{ sur }]0,T[\times \Omega\\
u&=&g_D\hbox{ sur }]0,T[\times \partial \Omega
\GSee
We use a time centered explicit scheme such that
\GSbe
M^{ass}\dsp\frac{U^{n+1}-2\,U^n+U^{n-1}}{\Delta t^2}+K\,U^n=M^{ass}\,F^n
\GSee
$M^{ass}$ and $K$ are respectively the Mass and Stiffness matrices.

The previous relation does not take into account boundary conditions.\\
We write the previous relation for non Dirichlet degrees of freedom, indexed by $IDc$. We have:
\GSbe
M^{ass}_{IDc,:}\dsp\frac{U^{n+1}-2\,U^n+U^{n-1}}{\Delta t^2}+K_{IDc,:}\,U^n=M^{ass}_{IDC,:}\,F^n
\GSee
As the unknown is $U^{n+1}_{IDc}$, we have:
\GSbe
M^{ass}_{IDc,IDc}\dsp\frac{U_{IDc}^{n+1}-2\,U_{IDc}^n+U_{IDc}^{n-1}}{\Delta t^2}+K_{IDc,:}\,U^n&=&\\
&=&M^{ass}_{IDC,:}\,F^n-M^{ass}_{IDc,ID}\dsp\frac{U_{ID}^{n+1}-2\,U_{ID}^n+U_{ID}^{n-1}}{\Delta t^2}
\GSee
Thus, the scheme is defined as follows:
\GSbe
U_{IDc}^{n+1}&=&2\,U_{IDc}^n-U_{IDc}^{n-1}\\
&&-\Delta t^2\,M^{ass^{-1}}_{IDc,IDc}\left(K_{IDc,:}\,U^n-M^{ass}_{IDC,:}\,F^n+M^{ass}_{IDc,ID}\dsp\frac{g_{D}^{n+1}-2\,U_{ID}^n+U_{ID}^{n-1}}{\Delta t^2}\right)
\GSee
So
\GSbe
\left\{
\begin{array}{lll}
U_{IDc}^{n+1}&=&2\,U_{IDc}^n-U_{IDc}^{n-1}+\Delta t^2\,F^n_{IDc}\\
&&-\Delta t^2\,M^{ass^{-1}}_{IDc,IDc}\left(K_{IDc,:}\,U^n-M^{ass}_{IDc,ID}\,F_{ID}^n+M^{ass}_{IDc,ID}\dsp\frac{g_{D}^{n+1}-2\,U_{ID}^n+U_{ID}^{n-1}}{\Delta t^2}\right)\\
U_{ID}^{n+1}&=&g_D^{n+1}
\end{array}
\right.
\GSee
This scheme needs to satisfy a CFL condition to converge.
\end{document}
